version: "3.2"
services:
        casd:
                build: ../../
                tty: true
                ports:
                        - 8085:8085
                command: bash -c "buildbox-casd --instance=dev --bind 0.0.0.0:8085 --verbose /tmp"
        recc:
                build: https://gitlab.com/BuildGrid/recc.git
                environment:
                        - RECC_CAS_SERVER=http://casd:8085
                        - RECC_CACHE_UPLOAD_LOCAL_BUILD=1
                        - RECC_VERBOSE=1
                        - RECC_DEPS_GLOBAL_PATHS=1
                        - RECC_INSTANCE=dev
                        - RECC_NO_PATH_REWRITE=1
                        - RECC_CACHE_ONLY=1
                        - RECC_REAPI_VERSION=2.2
                volumes:
                        - ./:/mnt
                command: bash -c " sleep 5 && cd /mnt &&
                         recc /usr/bin/g++ -c hello_world.cpp -o hello_world.o &&
                         rm -rf ./hello_world.o"
        casd2:
                build: ../../
                tty: true
                ports:
                        - 8086:8086
                command: bash -c "sleep 10 && buildbox-casd --instance=dev2 --cas-remote=http://casd:8085 --cas-instance=dev --ac-remote=http://casd:8085 --ac-instance=dev --bind 0.0.0.0:8086 --verbose /tmp/second/"
        recc2:
                build: https://gitlab.com/BuildGrid/recc.git
                environment:
                        - RECC_CAS_SERVER=http://casd2:8086
                        - RECC_CACHE_UPLOAD_LOCAL_BUILD=1
                        - RECC_VERBOSE=1
                        - RECC_DEPS_GLOBAL_PATHS=1
                        - RECC_INSTANCE=dev2
                        - RECC_NO_PATH_REWRITE=1
                        - RECC_CACHE_ONLY=1
                        - RECC_REAPI_VERSION=2.2
                volumes:
                        - ./:/mnt
                command: bash -c " sleep 15 && cd /mnt &&
                         recc /usr/bin/g++ -c hello_world.cpp -o hello_world.o"

# expected output:
# adBlobs request for instance name "" for 0 digest(s)
# casd2_1  | 2022-02-25T22:21:21.835+0000 [1:140324667635456] [buildboxcasd_localcasproxyinstance.cpp:219] [INFO] retrieved all digest(s) for instance name "" from local storage
# casd2_1  | 2022-02-25T22:21:21.835+0000 [1:140324667635456] [buildboxcasd_localcasproxyinstance.cpp:73] [INFO] LocalCasProxyInstance::FindMissingBlobs request for instance name "dev2" for 3 digest(s)
# casd_1   | 2022-02-25T22:21:21.836+0000 [1:139714580981504] [buildboxcasd_localcasinstance.cpp:58] [INFO] LocalCasInstance::FindMissingBlobs request for instance name "dev" for 3 digest(s)
# casd2_1  | 2022-02-25T22:21:21.836+0000 [1:140324667635456] [buildboxcasd_acinstance.cpp:111] [INFO] Output file/dir digest=e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855for actionresult=output_files {
# casd2_1  |   path: "hello_world.o"
# casd2_1  |   digest {
# casd2_1  |     hash: "48afe7e5ec066bd270840b71092b90c701ab4a0251a82a1e5bc9204b19c7314f"
# casd2_1  |     size_bytes: 2592
# casd2_1  |   }
# casd2_1  | }
# casd2_1  | stdout_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  | stderr_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  |  found
# casd2_1  | 2022-02-25T22:21:21.837+0000 [1:140324667635456] [buildboxcasd_acinstance.cpp:111] [INFO] Output file/dir digest=e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855for actionresult=output_files {
# casd2_1  |   path: "hello_world.o"
# casd2_1  |   digest {
# casd2_1  |     hash: "48afe7e5ec066bd270840b71092b90c701ab4a0251a82a1e5bc9204b19c7314f"
# casd2_1  |     size_bytes: 2592
# casd2_1  |   }
# casd2_1  | }
# casd2_1  | stdout_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  | stderr_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  |  found
# casd2_1  | 2022-02-25T22:21:21.837+0000 [1:140324667635456] [buildboxcasd_acinstance.cpp:111] [INFO] Output file/dir digest=48afe7e5ec066bd270840b71092b90c701ab4a0251a82a1e5bc9204b19c7314ffor actionresult=output_files {
# casd2_1  |   path: "hello_world.o"
# casd2_1  |   digest {
# casd2_1  |     hash: "48afe7e5ec066bd270840b71092b90c701ab4a0251a82a1e5bc9204b19c7314f"
# casd2_1  |     size_bytes: 2592
# casd2_1  |   }
# casd2_1  | }
# casd2_1  | stdout_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  | stderr_digest {
# casd2_1  |   hash: "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855"
# casd2_1  | }
# casd2_1  |  found
# casd2_1  | 2022-02-25T22:21:21.837+0000 [1:140324667635456] [buildboxcasd_localacproxyinstance.cpp:100] [INFO] ActionResult found for ActionDigest='86002cd08cdfff7b8872c16964fbbf24311788a335ff2fb0fde4f6d702daba9c/143'
# recc2_1  | 2022-02-25T22:21:21.838+0000 [1:140240673816384] [executioncontext.cpp:380] [INFO] Action Cache hit for [86002cd08cdfff7b8872c16964fbbf24311788a335ff2fb0fde4f6d702daba9c/143]
# casd2_1  | 2022-02-25T22:21:21.840+0000 [1:140324650850048] [buildboxcasd_localcasproxyinstance.cpp:191] [INFO] LocalCasProxyInstance::BatchReadBlobs request for instance name "dev2" for 2 digest(s)
# casd_1   | 2022-02-25T22:21:21.841+0000 [1:139714572588800] [buildboxcasd_localcasinstance.cpp:116] [INFO] LocalCasInstance::BatchReadBlobs request for instance name "dev" for 1 digest(s)
# casd2_1  | 2022-02-25T22:21:21.842+0000 [1:140324650850048] [buildboxcasd_localcasproxyinstance.cpp:257] [INFO] downloaded 1 out of 1 digest(s) from the remote cas server
# integration-test_recc2_1 exited with code 0
